CREATE OR REPLACE PACKAGE telsale_archievement_pkg IS

    -- Author  : WANGWEI-202
    -- Created : 2023/3/10 15:13:34
    -- Purpose : Ŀɰ

    TYPE cur_type IS REF CURSOR;

    PROCEDURE department_archievement
    (
        a_department_code IN VARCHAR2,
        a_attaching_rate  OUT VARCHAR2,
        a_renewal_rate    OUT VARCHAR2,
        a_total           OUT INTEGER,
        a_mensual_cur     OUT cur_type
    );

    PROCEDURE caller_arch_ranking_list
    (
        a_department_code     IN VARCHAR2,
        a_chefei_ranking_list OUT cur_type
    );

END telsale_archievement_pkg;
/
CREATE OR REPLACE PACKAGE BODY telsale_archievement_pkg IS

    -- ͸
    PROCEDURE department_archievement
    (
        a_department_code IN VARCHAR2,
        a_attaching_rate  OUT VARCHAR2,
        a_renewal_rate    OUT VARCHAR2,
        a_total           OUT INTEGER,
        a_mensual_cur     OUT cur_type
    ) IS
        l_this_month      VARCHAR2(4);
        l_this_year       VARCHAR2(4);
        l_firstday        DATE;
        l_department_name VARCHAR2(100);
    BEGIN
        l_this_month := to_char(SYSDATE,
                                'mm');
        l_this_year  := to_char(SYSDATE,
                                'yyyy');
        l_firstday   := to_date(to_char(SYSDATE,
                                        'yyyy') || '-01-01 00:00:00',
                                'yyyy-mm-dd hh24:mi:ss');
        -- ȡòŴ
        SELECT bm.department_name
          INTO l_department_name
          FROM idst0.bm_t bm
         WHERE bm.department_code = a_department_code;
    
        --͸
        SELECT decode(SUM(cf.ո˿ͻ),
                      0,
                      0,
                      round((SUM(cf.ںϱ) / SUM(cf.ո˿ͻ) * 100),
                            2))
          INTO a_attaching_rate
          FROM ϯÿձ cf
         WHERE cf.· = l_this_month
           AND cf. = l_this_year
           AND Ŵ = a_department_code;
    
        --
        SELECT decode(SUM(),
                      0,
                      0,
                      round(SUM(ۼ) / SUM() * 100,
                            2))
          INTO a_renewal_rate
          FROM ϯͳ
         WHERE  = l_department_name;
    
        --ҵ
        SELECT round(nvl(SUM(cf.ո˿ͻ + cf.ںϱ),
                         0),
                     0)
          INTO a_total
          FROM ϯÿձ cf
         WHERE Ŵ = a_department_code
           AND ǩ >= l_firstday
           AND ǩ <= SYSDATE;
    
        --ÿҵ
        OPEN a_mensual_cur FOR
            SELECT cf.· mm,
                   round(nvl(SUM(cf.ո˿ͻ + cf.ںϱ) / 10000,
                             0),
                         0) bf
              FROM ϯÿձ cf
             WHERE Ŵ = a_department_code
               AND ǩ >= to_date(to_char(SYSDATE,
                                           'yyyy') || '-01-01 00:00:00',
                                   'yyyy-mm-dd hh24:mi:ss')
               AND ǩ < to_date(to_char(SYSDATE,
                                          'yyyy-mm') || '-01 00:00:00',
                                  'yyyy-mm-dd hh24:mi:ss')
             GROUP BY cf.·
             ORDER BY cf.·;
    END;

    PROCEDURE caller_arch_ranking_list
    (
        a_department_code     IN VARCHAR2,
        a_chefei_ranking_list OUT cur_type
    ) IS
        l_current_month VARCHAR2(10);
        l_current_year  VARCHAR2(4);
    BEGIN
        l_current_month := to_char(SYSDATE,
                                   'mm');
        l_current_year  := to_char(SYSDATE,
                                   'yyyy');
    
        OPEN a_chefei_ranking_list FOR
            SELECT ϯ,
                   round(SUM(ںϱ) / SUM(ո˿ͻ) * 100,
                         2) ͸
              FROM ϯÿձ
             WHERE · = l_current_month
               AND  = l_current_year
               AND Ŵ = a_department_code
             GROUP BY ·,
                      Ŵ,
                      ϯ
            --HAVING · = '06'
             ORDER BY ͸ DESC;
    END;

BEGIN
    NULL;
END telsale_archievement_pkg;
/
